/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import ksu.cis.mom.*;
import java.io.*;
import java.awt.*;
import java.net.*;
/**
 * @author Chairoj Mekprasertvit
 *
 */
public class broadcast extends BroadcastConversation
{
  public agent_test parent;
  public String command;
  public String conversation_name;
  public TextArea display;
  public broadcast(
    agent_test agent,
    int b_port,
    InetAddress broadcast_address,
    String command,
    TextArea display)
  {
    super(agent, broadcast_address, b_port, agent.broadcast_queue);
    parent = agent;
    this.command = command;
    this.display = display;
    this.conversation_name = "broadcast";
  }

  public void run()
  {
    Message m = new Message();
    int state = 0;
    boolean notDone = true;
    int count = 0;
    try
    {
      while (notDone)
      {
        switch (state)
        {
          case 0 :
            m.performative = "calculate";
            m.content = command;
            startConversation(m, conversation_name, "BroadcastServer");
            state = 1;
            break;
          case 1 :
            //while(count < 3)
            //{
            m = readMessage("broadcast");
            if (m.performative.equals("reply"))
            {
              display.append((String) m.content + " from " + m.sender + "\n");
              notDone = false;
            }
            else
              parent.write("** ERROR - did not get reply back **");

            m = readMessage("broadcast");
            if (m.performative.equals("reply"))
            {
              display.append((String) m.content + " from " + m.sender + "\n");
              notDone = false;
            }
            else
              parent.write("** ERROR - did not get reply back **");
           //count++;
            //}
            break;
        }
      }
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in broadcast conversation.");
    }
  }
}
